<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>morphorobotx: ActuatorAxis.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">morphorobotx
   </div>
   <div id="projectbrief">morphorobotxsharedlibrary</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1.2 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Macros</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">ActuatorAxis.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="ActuatorAxis_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/* </span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * File:   ActuatorAxis.hpp</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Author: cfmadmin</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * Created on February 1, 2013, 9:09 PM</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef ACTUATORAXIS_HPP</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#define ACTUATORAXIS_HPP</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">//#include &quot;ActuatorSystem.hpp&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;QString&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">//#include &quot;StateManager.hpp&quot;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">class </span><a class="code" href="classActuatorSystem.html">ActuatorSystem</a>;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">class </span><a class="code" href="classStateManager.html">StateManager</a>;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div>
<div class="line"><a name="l00019"></a><span class="lineno"><a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532b">   19</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span> <a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532b">AxisOption</a></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;{</div>
<div class="line"><a name="l00021"></a><span class="lineno"><a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532ba3bc20f958bcb592803a5d2a8e36ed041">   21</a></span>&#160;    <a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532ba3bc20f958bcb592803a5d2a8e36ed041">GOTO_TIMEOUT_MS</a>=0,</div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532ba2fbb4bf4bfcdbc9ec5e99bee13593ad7">   22</a></span>&#160;    <a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532ba2fbb4bf4bfcdbc9ec5e99bee13593ad7">GOTO_HOLD_MS</a>=1,</div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532ba4f5a4a910b81b00f064a38d7a768261c">   23</a></span>&#160;    <a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532ba4f5a4a910b81b00f064a38d7a768261c">GOTO_PRECISION_MARGIN_MICRONS</a>=2,</div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532ba4f13f9d115590b7ceac2461c69c8bc63">   24</a></span>&#160;    <a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532ba4f13f9d115590b7ceac2461c69c8bc63">SPEED_LIMIT_MICRONS_PER_SECOND</a>=3,</div>
<div class="line"><a name="l00025"></a><span class="lineno"><a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532bae2a096761eb95b780bbe09345302978d">   25</a></span>&#160;    <a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532bae2a096761eb95b780bbe09345302978d">FREQUENCY_LIMIT_HZ</a>=4,</div>
<div class="line"><a name="l00026"></a><span class="lineno"><a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532baa7ce6a8db124c60e910cf9fcef4f255c">   26</a></span>&#160;    <a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532baa7ce6a8db124c60e910cf9fcef4f255c">ACCELERATION_LIMIT_MICRONS_PER_SECOND_SQUARE</a>=5    </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;} <a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532b">AxisOption</a>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="code" href="classActuatorAxis.html">   29</a></span>&#160;<span class="keyword">class </span><a class="code" href="classActuatorAxis.html">ActuatorAxis</a> {</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <a class="code" href="classActuatorAxis.html#a44f10b95649ce1f680513649431f8416">ActuatorAxis</a>(<a class="code" href="classActuatorSystem.html">ActuatorSystem</a>* actuatorSystem, <a class="code" href="classStateManager.html">StateManager</a>&amp; stateManager, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> localID);</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="comment">//ActuatorAxis(const ActuatorAxis&amp; orig);</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classActuatorAxis.html#ac7b79d4664ceae76696123345da1142e">~ActuatorAxis</a>();</div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="code" href="classActuatorAxis.html#a8bc7f956edd8d06be18c35b7dc56dcfd">   34</a></span>&#160;    <a class="code" href="classActuatorSystem.html">ActuatorSystem</a>* <a class="code" href="classActuatorAxis.html#a8bc7f956edd8d06be18c35b7dc56dcfd">itsActuatorSystem</a>()</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    {</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classActuatorAxis.html#a6b6efecf3da0f3eeb32a4cd32479d995" title="writes actual values to the state">_itsActuatorSystem</a>;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    }</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classActuatorAxis.html#aca6e394e1b956fb2797356caa2a62b38">GotoAsync</a>(<span class="keywordtype">double</span> positionMicrons)=0;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classActuatorAxis.html#a3022184603571d9dd94e51377a275317">GotoSync</a>(<span class="keywordtype">double</span> positionMicrons)=0;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classActuatorAxis.html#aafe1cceab42834d85a6a4750fa33af32">GetPositionSync</a>(<span class="keywordtype">double</span>&amp; positionMicrons)=0;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classActuatorAxis.html#ade40b5431a0f3744b7c1f4c51db183a2">SetOption</a>(<a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532b">AxisOption</a> option, <span class="keywordtype">double</span> value)=0;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="comment">//virtual bool RegisterFields()=0;</span></div>
<div class="line"><a name="l00043"></a><span class="lineno"><a class="code" href="classActuatorAxis.html#a7dd8846038e9dcbbf62396d862fcc373">   43</a></span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classActuatorAxis.html#a7dd8846038e9dcbbf62396d862fcc373">LocalID</a>()</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    {</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classActuatorAxis.html#a05cfdb4b4d674731c01174526cf732c0">_localID</a>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    }</div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="code" href="classActuatorAxis.html#abc90e3048dfb8b5895e62fab2a790a79">   47</a></span>&#160;    QString <a class="code" href="classActuatorAxis.html#abc90e3048dfb8b5895e62fab2a790a79">Name</a>()</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classActuatorAxis.html#ade9139dcc1beec6a53850fd2025a4bb6">_name</a>;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    }</div>
<div class="line"><a name="l00051"></a><span class="lineno"><a class="code" href="classActuatorAxis.html#a25534aa53fbcfc4c97aa5bc03988f1d1">   51</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classActuatorAxis.html#a25534aa53fbcfc4c97aa5bc03988f1d1">SetName</a>(QString name)</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    {</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <a class="code" href="classActuatorAxis.html#ade9139dcc1beec6a53850fd2025a4bb6">_name</a> = name;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    }</div>
<div class="line"><a name="l00055"></a><span class="lineno"><a class="code" href="classActuatorAxis.html#a4393c05ae71e2764aba1b0c94edfad44">   55</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classActuatorAxis.html#a4393c05ae71e2764aba1b0c94edfad44">SetFlip</a>(<span class="keywordtype">signed</span> <span class="keywordtype">int</span> flip)</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    {</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <a class="code" href="classActuatorAxis.html#af6dcef5df7963f49ed7adde1326f618c">_flip</a> = flip;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    }</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classActuatorAxis.html#a1710903e65c20383d05070a32b16313f">RegisterFields</a>()=0;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classActuatorAxis.html#af0d2d584df9a4b7cc7e90bcf8d752f7d">UpdateState</a>()=0;    </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="code" href="classActuatorAxis.html#a6b6efecf3da0f3eeb32a4cd32479d995">   63</a></span>&#160;    <a class="code" href="classActuatorSystem.html">ActuatorSystem</a>* <a class="code" href="classActuatorAxis.html#a6b6efecf3da0f3eeb32a4cd32479d995" title="writes actual values to the state">_itsActuatorSystem</a>;</div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="code" href="classActuatorAxis.html#aff589b293bba5593dd00a11c08c99eeb">   64</a></span>&#160;    <a class="code" href="classStateManager.html">StateManager</a>&amp; <a class="code" href="classActuatorAxis.html#aff589b293bba5593dd00a11c08c99eeb">_stateManager</a>;</div>
<div class="line"><a name="l00065"></a><span class="lineno"><a class="code" href="classActuatorAxis.html#a05cfdb4b4d674731c01174526cf732c0">   65</a></span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classActuatorAxis.html#a05cfdb4b4d674731c01174526cf732c0">_localID</a>;</div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="code" href="classActuatorAxis.html#a21ca9c4ab807f8d2a09ee2f57bbd6b82">   66</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classActuatorAxis.html#a21ca9c4ab807f8d2a09ee2f57bbd6b82">holdMs</a>;</div>
<div class="line"><a name="l00067"></a><span class="lineno"><a class="code" href="classActuatorAxis.html#ade9139dcc1beec6a53850fd2025a4bb6">   67</a></span>&#160;    QString <a class="code" href="classActuatorAxis.html#ade9139dcc1beec6a53850fd2025a4bb6">_name</a>;</div>
<div class="line"><a name="l00068"></a><span class="lineno"><a class="code" href="classActuatorAxis.html#af6dcef5df7963f49ed7adde1326f618c">   68</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classActuatorAxis.html#af6dcef5df7963f49ed7adde1326f618c">_flip</a>;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;};</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00071"></a><span class="lineno"><a class="code" href="classRobotException.html">   71</a></span>&#160;<span class="keyword">class </span><a class="code" href="classRobotException.html">RobotException</a>: <span class="keyword">public</span> std::exception</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;{    </div>
<div class="line"><a name="l00073"></a><span class="lineno"><a class="code" href="classRobotException.html#a116fcfc18716b60880620b5ecadc975e">   73</a></span>&#160;    <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classRobotException.html#a116fcfc18716b60880620b5ecadc975e">what</a>() <span class="keyword">const</span> throw()</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    {        </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keywordflow">return</span> <span class="stringliteral">&quot;Robot Exception&quot;</span>;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    }</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;};</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* ACTUATORAXIS_HPP */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Feb 26 2013 17:54:10 for morphorobotx by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1.2
</small></address>
</body>
</html>
